clang-tools 10.0.0

Public Member Functions | List of all members
clang::tidy::cppcoreguidelines::InitVariablesCheck Class Reference

Find uninitialized local variables. More...

`#include <InitVariablesCheck.h>`

Inheritance diagram for clang::tidy::cppcoreguidelines::InitVariablesCheck:
[legend]
Collaboration diagram for clang::tidy::cppcoreguidelines::InitVariablesCheck:
[legend]

## Public Member Functions
| InitVariablesCheck (StringRef Name, ClangTidyContext *Context)
void | registerPPCallbacks (const SourceManager &SM, Preprocessor *PP, Preprocessor *ModuleExpanderPP) override
| Override this to register `PPCallbacks` in the preprocessor. More...
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| Override this to register AST matchers with `Finder`. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...
virtual void | storeOptions (ClangTidyOptions::OptionMap &Options)
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
const LangOptions & | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

Find uninitialized local variables.

For the user-facing documentation see: http://clang.llvm.org/extra/clang-tidy/checks/cppcoreguidelines-init-variables.html

Definition at line 24 of file InitVariablesCheck.h.

## Constructor & Destructor Documentation

## ◆ InitVariablesCheck()

clang::tidy::cppcoreguidelines::InitVariablesCheck::InitVariablesCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |

Definition at line 24 of file InitVariablesCheck.cpp.

## Member Function Documentation

## ◆ check()

void clang::tidy::cppcoreguidelines::InitVariablesCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 51 of file InitVariablesCheck.cpp.

## ◆ registerMatchers()

void clang::tidy::cppcoreguidelines::InitVariablesCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

Override this to register AST matchers with `Finder`.

This should be used by clang-tidy checks that analyze code properties that dependent on AST knowledge.

You can register as many matchers as necessary with `Finder`. Usually, "this" will be used as callback, but you can also specify other callback classes. Thereby, different matchers can trigger different callbacks.

If you need to merge information between the different matchers, you can store these as members of the derived class. However, note that all matches occur in the order of the AST traversal.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 31 of file InitVariablesCheck.cpp.

## ◆ registerPPCallbacks()

void clang::tidy::cppcoreguidelines::InitVariablesCheck::registerPPCallbacks | ( | const SourceManager & | SM,
|  | Preprocessor * | PP,
|  | Preprocessor * | ModuleExpanderPP
| ) |  |
| override virtual

Override this to register `PPCallbacks` in the preprocessor.

This should be used for clang-tidy checks that analyze preprocessor- dependent properties, e.g. include directives and macro definitions.

There are two Preprocessors to choose from that differ in how they handle modular #includes:

- PP is the real Preprocessor. It doesn't walk into modular #includes and thus doesn't generate PPCallbacks for their contents.
- ModuleExpanderPP preprocesses the whole translation unit in the non-modular mode, which allows it to generate PPCallbacks not only for the main file and textual headers, but also for all transitively included modular headers when the analysis runs with modules enabled. When modules are not enabled ModuleExpanderPP just points to the real preprocessor.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 43 of file InitVariablesCheck.cpp.

The documentation for this class was generated from the following files:

- InitVariablesCheck.h
- InitVariablesCheck.cpp